#include "../../src/Battling/Library/BattleLibrary.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

export_func u8 CreatureLib_BattleLibrary_Construct(const BattleLibrary*& out,
                                                   const CreatureLib::Library::DataLibrary* staticLib,
                                                   BattleStatCalculator* statCalculator, DamageLibrary* damageLibrary,
                                                   ExperienceLibrary* experienceLibrary, ScriptResolver* scriptResolver,
                                                   MiscLibrary* miscLibrary) {
    Try(out = new BattleLibrary(staticLib, statCalculator, damageLibrary, experienceLibrary, scriptResolver,
                                miscLibrary);)
}

export_func void CreatureLib_BattleLibrary_Destruct(const BattleLibrary* p) { delete p; }

SMART_GET_FUNC(BattleLibrary, GetStaticLib, const CreatureLib::Library::DataLibrary*);
SMART_GET_FUNC(BattleLibrary, GetStatCalculator, const BattleStatCalculator*);
SMART_GET_FUNC(BattleLibrary, GetDamageLibrary, const DamageLibrary*);
SMART_GET_FUNC(BattleLibrary, GetMiscLibrary, const MiscLibrary*);
SMART_GET_FUNC(BattleLibrary, GetExperienceLibrary, const ExperienceLibrary*);
SMART_GET_FUNC(BattleLibrary, GetScriptResolver, ScriptResolver*);
