#include "../../src/Battling/Models/BattleParty.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

// Note that creatureIndices should be twice the size of numberOfIndices, and have index of side, index of creature on
// side, one after the other.
export_func u8 CreatureLib_BattleParty_Construct(BattleParty*& out, CreatureParty* p, u8 creatureIndices[],
                                                 size_t numberOfIndices) {
    Try(ArbUt::List<CreatureIndex> indices(numberOfIndices); for (size_t i = 0; i < numberOfIndices; i++) {
        indices.Append(CreatureIndex(creatureIndices[i * 2], creatureIndices[i * 2 + 1]));
    } out = new BattleParty(p, indices);)
}

export_func void CreatureLib_BattleParty_Destruct(const BattleParty* p) { delete p; }

BORROWED_GET_FUNC(BattleParty, GetParty, CreatureParty*);
export_func u8 CreatureLib_BattleParty_IsResponsibleForIndex(bool& out, const BattleParty* p, u8 side, u8 creature) {
    Try(out = p->IsResponsibleForIndex(side, creature);)
}
export_func bool CreatureLib_BattleParty_HasCreaturesNotInField(const BattleParty* p) {
    return p->HasCreaturesNotInField();
}
