#include "../../src/Battling/Models/BattleRandom.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

export_func BattleRandom* CreatureLib_BattleRandom_Construct() { return new BattleRandom(); }
export_func BattleRandom* CreatureLib_BattleRandom_ConstructWithSeed(uint_fast32_t seed) {
    return new BattleRandom(seed);
}

export_func void CreatureLib_BattleRandom_Destruct(BattleRandom* p) { delete p; }

export_func i8 CreatureLib_BattleRandom_EffectChance(bool& out, BattleRandom* p, float chance, ExecutingAttack* attack,
                                                     Creature* target) {
    Try(out = p->EffectChance(chance, attack, target);)
}

export_func i32 CreatureLib_BattleRandom_Get(BattleRandom* p) { return p->Get(); }
export_func i32 CreatureLib_BattleRandom_GetMax(BattleRandom* p, i32 max) { return p->Get(max); }
export_func i32 CreatureLib_BattleRandom_GetMinMax(BattleRandom* p, i32 min, i32 max) { return p->Get(min, max); }
export_func uint_fast32_t CreatureLib_BattleRandom_GetSeed(BattleRandom* p) { return p->GetSeed(); }
