#include "../../src/Library/DataLibrary.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Library;

export_func u8 CreatureLib_DataLibrary_Construct(const DataLibrary*& out, LibrarySettings* settings,
                                                 SpeciesLibrary* species, AttackLibrary* attacks, ItemLibrary* items,
                                                 GrowthRateLibrary* growthRates, TypeLibrary* typeLibrary,
                                                 TalentLibrary* talentLibrary) {
    Try(out = new DataLibrary(settings, species, attacks, items, growthRates, typeLibrary, talentLibrary);)
}

export_func void CreatureLib_DataLibrary_Destruct(const DataLibrary* p) { delete p; }

SMART_GET_FUNC(DataLibrary, GetSettings, const LibrarySettings*);
SMART_GET_FUNC(DataLibrary, GetSpeciesLibrary, const SpeciesLibrary*);
SMART_GET_FUNC(DataLibrary, GetAttackLibrary, const AttackLibrary*);
SMART_GET_FUNC(DataLibrary, GetItemLibrary, const ItemLibrary*);
SMART_GET_FUNC(DataLibrary, GetGrowthRates, const GrowthRateLibrary*);
SMART_GET_FUNC(DataLibrary, GetTypeLibrary, const TypeLibrary*);
SMART_GET_FUNC(DataLibrary, GetTalentLibrary, const TalentLibrary*);