#include "../../src/Library/EffectParameter.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Library;

export_func EffectParameter* CreatureLib_EffectParameter_FromBool(bool b) { return new EffectParameter(b); }
export_func EffectParameter* CreatureLib_EffectParameter_FromInt(i64 i) { return new EffectParameter(i); }
export_func EffectParameter* CreatureLib_EffectParameter_FromFloat(float f) { return new EffectParameter(f); }
export_func EffectParameter* CreatureLib_EffectParameter_FromString(const char* c) {
    return new EffectParameter(ArbUt::StringView(c));
}

export_func void CreatureLib_EffectParameter_Destruct(const EffectParameter* p) { delete p; }
export_func EffectParameterType CreatureLib_EffectParameter_GetType(const EffectParameter* p) { return p->GetType(); }
export_func u8 CreatureLib_EffectParameter_AsBool(const EffectParameter* p, bool& out) { Try(out = p->AsBool();) }
export_func u8 CreatureLib_EffectParameter_AsInt(const EffectParameter* p, i64& out) { Try(out = p->AsInt();) }
export_func u8 CreatureLib_EffectParameter_AsFloat(const EffectParameter* p, float& out) { Try(out = p->AsFloat();) }
export_func u8 CreatureLib_EffectParameter_AsString(const EffectParameter* p, const char*& out) {
    Try(out = p->AsString().c_str();)
}
