#ifndef CREATURELIB_ATTACKUSEEVENT_HPP
#define CREATURELIB_ATTACKUSEEVENT_HPP
#include "../../Models/ExecutingAttack.hpp"
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class AttackUseEvent final : public EventData {
        ArbUt::BorrowedPtr<ExecutingAttack> _attack;

    public:
        AttackUseEvent(const ArbUt::BorrowedPtr<ExecutingAttack>& attack) noexcept : _attack(attack) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::AttackUse; }
        const ArbUt::BorrowedPtr<ExecutingAttack>& GetAttack() const noexcept { return _attack; }
    };
}

#endif // CREATURELIB_ATTACKUSEEVENT_HPP
