#ifndef CREATURELIB_CHANGESPECIESEVENT_HPP
#define CREATURELIB_CHANGESPECIESEVENT_HPP
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class ChangeSpeciesEvent final : public EventData {
        const ArbUt::BorrowedPtr<Creature> _creature;
        const ArbUt::BorrowedPtr<const CreatureLib::Library::CreatureSpecies> _newSpecies;

    public:
        ChangeSpeciesEvent(const ArbUt::BorrowedPtr<Creature>& creature,
                           const ArbUt::BorrowedPtr<const CreatureLib::Library::CreatureSpecies>& species) noexcept
            : _creature(creature), _newSpecies(species) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::ChangeSpecies; }
        const ArbUt::BorrowedPtr<Creature>& GetCreature() const noexcept { return _creature; }
        const ArbUt::BorrowedPtr<const CreatureLib::Library::CreatureSpecies>& GetNewSpecies() const noexcept {
            return _newSpecies;
        }
    };
}

#endif // CREATURELIB_CHANGESPECIESEVENT_HPP
