#ifndef CREATURELIB_CHANGEVARIANTEVENT_HPP
#define CREATURELIB_CHANGEVARIANTEVENT_HPP
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class ChangeVariantEvent final : public EventData {
        const ArbUt::BorrowedPtr<Creature> _creature;
        const ArbUt::BorrowedPtr<const CreatureLib::Library::SpeciesVariant> _newVariant;

    public:
        ChangeVariantEvent(const ArbUt::BorrowedPtr<Creature>& creature,
                           const ArbUt::BorrowedPtr<const CreatureLib::Library::SpeciesVariant>& variant) noexcept
            : _creature(creature), _newVariant(variant) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::ChangeVariant; }
        const ArbUt::BorrowedPtr<Creature>& GetCreature() const noexcept { return _creature; }
        const ArbUt::BorrowedPtr<const CreatureLib::Library::SpeciesVariant>& GetNewVariant() const noexcept {
            return _newVariant;
        }
    };
}

#endif // CREATURELIB_CHANGEVARIANTEVENT_HPP
