#ifndef CREATURELIB_MISSEVENT_HPP
#define CREATURELIB_MISSEVENT_HPP
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class MissEvent final : public EventData {
        ArbUt::BorrowedPtr<Creature> _creature;

    public:
        explicit MissEvent(const ArbUt::BorrowedPtr<Creature>& creature) noexcept : _creature(creature) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::Miss; }
        const ArbUt::BorrowedPtr<Creature>& GetCreature() const noexcept { return _creature; }
    };
}
#endif // CREATURELIB_MISSEVENT_HPP
