#ifndef SWAPEVENT_HPP
#define SWAPEVENT_HPP

namespace CreatureLib::Battling {
    class SwapEvent final : public EventData {
        u8 _sideIndex;
        u8 _positionA;
        u8 _positionB;

    public:
        SwapEvent(u8 sideIndex, u8 positionA, u8 positionB) noexcept
            : _sideIndex(sideIndex), _positionA(positionA), _positionB(positionB) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::Swap; }

        inline u8 GetSideIndex() const noexcept { return _sideIndex; }
        inline u8 GetPositionA() const noexcept { return _positionA; }
        inline u8 GetPositionB() const noexcept { return _positionB; }
    };
}

#endif // SWAPEVENT_HPP
