#ifndef CREATURELIB_SWITCHEVENT_HPP
#define CREATURELIB_SWITCHEVENT_HPP
#include "../../Models/CreatureIndex.hpp"
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class SwitchEvent final : public EventData {
        CreatureIndex _index;
        ArbUt::BorrowedPtr<Creature> _newCreature;

    public:
        SwitchEvent(const CreatureIndex& index, const ArbUt::BorrowedPtr<Creature>& newCreature)
            : _index(index), _newCreature(newCreature) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::Switch; }
        const CreatureIndex& GetIndex() const noexcept { return _index; }
        const ArbUt::BorrowedPtr<Creature>& GetNewCreature() const noexcept { return _newCreature; }
    };
}

#endif // CREATURELIB_SWITCHEVENT_HPP
