#ifndef CREATURELIB_ATTACKUSEHISTORY_HPP
#define CREATURELIB_ATTACKUSEHISTORY_HPP
#include "../../Models/ExecutingAttack.hpp"
#include "HistoryElement.hpp"

namespace CreatureLib::Battling {
    class AttackUseHistory final : public HistoryElement {
        std::unique_ptr<const ExecutingAttack> _attack;

    public:
        AttackUseHistory(u32 turn, const ExecutingAttack* attack) : HistoryElement(turn), _attack(attack) {}
        ~AttackUseHistory() {
            if (_attack != nullptr) {
                _attack.reset();
            }
        }

        HistoryElementKind GetKind() const noexcept override { return HistoryElementKind::AttackUse; }
        ArbUt::BorrowedPtr<const ExecutingAttack> GetAttack() const noexcept { return _attack; }
    };
}

#endif // CREATURELIB_ATTACKUSEHISTORY_HPP
