#ifndef CREATURELIB_DAMAGEHISTORY_HPP
#define CREATURELIB_DAMAGEHISTORY_HPP
#include "../../Models/Creature.hpp"
#include "../../Models/DamageSource.hpp"
#include "HistoryElement.hpp"

namespace CreatureLib::Battling {
    class DamageHistory final : public HistoryElement {
        ArbUt::BorrowedPtr<CreatureLib::Battling::Creature> _target;
        u32 _amount;
        DamageSource _source;

    public:
        DamageHistory(u32 turn, ArbUt::BorrowedPtr<CreatureLib::Battling::Creature> target, u32 amount,
                      DamageSource source)
            : HistoryElement(turn), _target(target), _amount(amount), _source(source) {}

        HistoryElementKind GetKind() const noexcept override { return HistoryElementKind::Damage; }

        inline ArbUt::BorrowedPtr<CreatureLib::Battling::Creature> GetTarget() const noexcept { return _target; }
        inline u32 GetAmount() const noexcept { return _amount; }
        inline DamageSource GetDamageSource() const noexcept { return _source; }
    };
}

#endif // CREATURELIB_DAMAGEHISTORY_HPP
