#ifndef CREATURELIB_HISTORYELEMENT_HPP
#define CREATURELIB_HISTORYELEMENT_HPP

#include <Arbutils/Memory/Memory.hpp>
#include "../../../Defines.hpp"
#include "../HistoryElementKind.hpp"

namespace CreatureLib::Battling {
    class HistoryElement {
        ArbUt::OptionalUniquePtr<HistoryElement> _previous;
        u32 _turnNumber;

    public:
        HistoryElement(u32 turn) : _turnNumber(turn) {}
        virtual ~HistoryElement() {}

        [[nodiscard]] virtual HistoryElementKind GetKind() const noexcept = 0;
        [[nodiscard]] ArbUt::OptionalBorrowedPtr<const HistoryElement> GetPrevious() const noexcept {
            return _previous.GetValue();
        }

        ArbUt::OptionalBorrowedPtr<HistoryElement> GetPrevious() noexcept { return _previous.GetValue(); }

        void SetPrevious(HistoryElement* el) noexcept { _previous = el; }

        inline u32 GetTurnNumber() const noexcept { return _turnNumber; }
    };

}

#endif // CREATURELIB_HISTORYELEMENT_HPP
