#ifndef CREATURELIB_BATTLESTATCALCULATOR_HPP
#define CREATURELIB_BATTLESTATCALCULATOR_HPP

#include "../../Library/StatisticSet.hpp"

namespace CreatureLib::Battling {
    // predeclare BattleCreature class
    class Creature;

    class BattleStatCalculator {
    public:
        virtual ~BattleStatCalculator() = default;

        virtual Library::StatisticSet<u32> CalculateFlatStats(Creature* non_null creature) const;
        virtual Library::StatisticSet<u32> CalculateBoostedStats(Creature* non_null creature) const;
        virtual u32 CalculateFlatStat(Creature* non_null creature, Library::Statistic stat) const;
        virtual u32 CalculateBoostedStat(Creature* non_null creature, Library::Statistic stat) const;
    };
}

#endif // CREATURELIB_BATTLESTATCALCULATOR_HPP
