#ifndef CREATURELIB_DAMAGELIBRARY_HPP
#define CREATURELIB_DAMAGELIBRARY_HPP

#include "../Models/Creature.hpp"
#include "../Models/ExecutingAttack.hpp"

namespace CreatureLib::Battling {
    class DamageLibrary {
    public:
        virtual ~DamageLibrary() = default;
        virtual u32 GetDamage(ExecutingAttack* non_null attack, Creature* non_null target, u8 hitIndex,
                              const ExecutingAttack::HitData& hitData) const;

        virtual u8 GetBasePower(ExecutingAttack* non_null attack, Creature* non_null target, u8 hitIndex,
                                const ExecutingAttack::HitData& hitData) const;
        virtual float GetStatModifier(ExecutingAttack* non_null attack, Creature* non_null target, u8 hitIndex,
                                      const ExecutingAttack::HitData& hitData) const;
        virtual float GetDamageModifier(ExecutingAttack* non_null attack, Creature* non_null target, u8 hitIndex,
                                        const ExecutingAttack::HitData& hitData) const;
    };
}

#endif // CREATURELIB_DAMAGELIBRARY_HPP
