#include "ExperienceLibrary.hpp"
#include "../Models/Creature.hpp"

void CreatureLib::Battling::ExperienceLibrary::HandleExperienceGain(
    CreatureLib::Battling::Creature* non_null faintedMon,
    const std::unordered_set<ArbUt::BorrowedPtr<Creature>>& opponents) const {
    for (const auto& opponent : opponents) {
        if (opponent->IsFainted())
            continue;
        if (!opponent->AllowedExperienceGain())
            continue;
        auto levelDiff = faintedMon->GetLevel() - opponent->GetLevel() + 10;
        if (levelDiff <= 0)
            continue;
        auto experienceGain = levelDiff * 10;
        opponent->AddExperience(static_cast<u32>(experienceGain));
    }
}
