#ifndef CREATURELIB_FLEETURNCHOICE_HPP
#define CREATURELIB_FLEETURNCHOICE_HPP

#include "../Models/Creature.hpp"
#include "BaseTurnChoice.hpp"

namespace CreatureLib::Battling {
    class FleeTurnChoice : public BaseTurnChoice {
    public:
        FleeTurnChoice(ArbUt::BorrowedPtr<Creature> user) : BaseTurnChoice(user) {}

        TurnChoiceKind GetKind() const noexcept override { return TurnChoiceKind ::Flee; }
        size_t ScriptCount() const override { return GetUser()->ScriptCount(); }

    protected:
        void GetActiveScripts(ArbUt::List<ScriptWrapper>& scripts) override { GetUser()->GetActiveScripts(scripts); }
        void GetOwnScripts(ArbUt::List<ScriptWrapper>&) override {}
    };
}

#endif // CREATURELIB_FLEETURNCHOICE_HPP
