#ifndef CREATURELIB_PASSTURNCHOICE_HPP
#define CREATURELIB_PASSTURNCHOICE_HPP

#include "BaseTurnChoice.hpp"

namespace CreatureLib::Battling {
    class PassTurnChoice : public BaseTurnChoice {
    public:
        PassTurnChoice(ArbUt::BorrowedPtr<Creature> c) : BaseTurnChoice(c) {}

        TurnChoiceKind GetKind() const noexcept override { return TurnChoiceKind ::Pass; }
        size_t ScriptCount() const override { return GetUser()->ScriptCount(); }

    protected:
        void GetActiveScripts(ArbUt::List<ScriptWrapper>& scripts) override { GetUser()->GetActiveScripts(scripts); }
        void GetOwnScripts(ArbUt::List<ScriptWrapper>&) override {}
    };
}

#endif // CREATURELIB_PASSTURNCHOICE_HPP
