#include "DataLibrary.hpp"

CreatureLib::Library::DataLibrary::DataLibrary(LibrarySettings* non_null settings,
                                               CreatureLib::Library::SpeciesLibrary* non_null species,
                                               CreatureLib::Library::AttackLibrary* non_null attacks,
                                               CreatureLib::Library::ItemLibrary* non_null items,
                                               CreatureLib::Library::GrowthRateLibrary* non_null growthRates,
                                               TypeLibrary* typeLibrary, TalentLibrary* non_null talentLibrary)
    : _settings(settings), _species(species), _attacks(attacks), _items(items), _growthRates(growthRates),
      _typeLibrary(typeLibrary), _talentLibrary(talentLibrary) {
    EnsureNotNull(_settings)
    EnsureNotNull(_species)
    EnsureNotNull(_attacks)
    EnsureNotNull(_items)
    EnsureNotNull(_growthRates)
    EnsureNotNull(_typeLibrary)
    EnsureNotNull(_talentLibrary)
}