#include "LibrarySettings.hpp"

namespace CreatureLib::Library {
    struct LibrarySettings::impl {
        level_int_t _maximalLevel;
        u8 _maximalAttacks;

    public:
        impl(level_int_t maximalLevel, u8 maximalAttacks)
            : _maximalLevel(maximalLevel), _maximalAttacks(maximalAttacks) {}

        [[nodiscard]] inline level_int_t GetMaximalLevel() const noexcept { return _maximalLevel; }

        [[nodiscard]] inline u8 GetMaximalAttacks() const noexcept { return _maximalAttacks; }
    };
    LibrarySettings::LibrarySettings(level_int_t maximalLevel, u8 maximalAttacks)
        : _impl(new impl(maximalLevel, maximalAttacks)) {}
    LibrarySettings::~LibrarySettings() = default;

    level_int_t LibrarySettings::GetMaximalLevel() const noexcept { return _impl->GetMaximalLevel(); }
    u8 LibrarySettings::GetMaximalAttacks() const noexcept { return _impl->GetMaximalAttacks(); }
}